Program DC64; { C64-Disassembler }

{ Project : IMPOSSIBLE-MISSION }

{
  C64 Disassembler v1.0
  Copyright (C) 1998  Paul TOTH <tothpaul@multimania.com>

  http://www.multimania/tothpaul

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

}

uses fdos,fsys;

const
 BasicTokens:array[#128..#203] of pchar=(
  'END','FOR','NEXT','DATA','INPUT#','INPUT','DIM','READ','LET','GOTO',
  'RUN','IF','RESTORE','GOSUB','RETURN','REM','STOP','ON','WAIT','LOAD',
  'SAVE','VERIFY','DEF','POKE','PRINT#','PRINT','CONT','LIST','CLR','CMD',
  'SYS','OPEN','CLOSE','GET','NEW',

  'TAB(','TO','FN','SPC(','THEN','NOT','STEP','+','-','*','/','^','AND',
  'OR','>','=','<','SGN','INT','ABS','USR','FRE','POS','SQR','RND','LOG',
  'EXP','COS','SIN','TAN','ATN','PEEK','LEN','STR$','VAL','ASC','CHR$',
  'LEFT$','RIGHT$','MID$',

  'GO'
 );

 MaxTarget=1000;

Type
 TParm=(
  p0,
  pImpl, { no parameters }
  pAbso, { word }
  pZPge, { byte }
  pImm,  { #byte }
  pAbsX, { word+x }
  pAbsY, { word+y }
  pIndX, { [byte+x] = array[x]^ }
  pIndY, { [byte]+y = array^[y] }
  pZPgX, { byte+x }
  pZPgY, { byte+y }
  pRela, { shortint(byte) }
  pInd   { [word] }
 );

 TOpCode=record
  Name:array[1..3] of char;
  Parm:TParm;
 end;

Const
 opSize:array[TParm] of byte=(
  1,1,3,2,2,3,3,2,2,2,2,2,3
 );

 OpCode:Array[0..255] of TOpCode = (
 {00-0F}
  (Name:'BRK'; Parm:pImpl),  (Name:'ORA'; Parm:pIndX),
  (Name:'JAM'; Parm:pImpl),  (Name:'SLO'; Parm:pIndX),
  (Name:'NOP'; Parm:pZpge),  (Name:'ORA'; Parm:pZPge),
  (Name:'ASL'; Parm:pZPge),  (Name:'SLO'; Parm:pZPge),
  (Name:'PHP'; Parm:pImpl),  (Name:'ORA'; Parm:pImm),
  (Name:'ASL'; Parm:pImpl),  (Name:'ANC'; Parm:pImm),
  (Name:'NOP'; Parm:pAbso),  (Name:'ORA'; Parm:pAbso),
  (Name:'ASL'; Parm:pAbso),  (Name:'   '; Parm:p0   ),
 {10-1F}
  (Name:'BPL'; Parm:pRela),  (Name:'ORA'; Parm:pIndY),
  (Name:'   '; Parm:p0   ),  (Name:'SLO'; Parm:pIndY),
  (Name:'NOP'; Parm:pZPgX),  (Name:'ORA'; Parm:pZPgX),
  (Name:'ASL'; Parm:pZPgX),  (Name:'   '; Parm:p0   ),
  (Name:'CLC'; Parm:pImpl),  (Name:'ORA'; Parm:pAbsY),
  (Name:'   '; Parm:p0   ),  (Name:'   '; Parm:p0   ),
  (Name:'   '; Parm:p0   ),  (Name:'ORA'; Parm:pAbsX),
  (Name:'ASL'; Parm:pAbsX),  (Name:'   '; Parm:p0   ),
 {20-2F}
  (Name:'JSR'; Parm:pAbso),  (Name:'AND'; Parm:pIndX),
  (Name:'   '; Parm:p0   ),  (Name:'RLA'; Parm:pIndX),
  (Name:'BIT'; Parm:pZPge),  (Name:'AND'; Parm:pZPge),
  (Name:'ROL'; Parm:pZPge),  (Name:'RLA'; Parm:pZPge),
  (Name:'PLP'; Parm:pImpl),  (Name:'AND'; Parm:pImm),
  (Name:'ROL'; Parm:pImpl),  (Name:'   '; Parm:p0   ),
  (Name:'BIT'; Parm:pAbso),  (Name:'AND'; Parm:pAbso),
  (Name:'ROL'; Parm:pAbso),  (Name:'RLA'; Parm:pAbso),
 {30-3F}
  (Name:'BMI'; Parm:pRela),  (Name:'AND'; Parm:pIndY),
  (Name:'   '; Parm:p0   ),  (Name:'RLA'; Parm:pIndY),
  (Name:'   '; Parm:p0   ),  (Name:'AND'; Parm:pZPgX),
  (Name:'ROL'; Parm:pZPgX),  (Name:'RLA'; Parm:pZPgX),
  (Name:'SEC'; Parm:pImpl),  (Name:'AND'; Parm:pAbsY),
  (Name:'   '; Parm:p0   ),  (Name:'RLA'; Parm:pAbsY),
  (Name:'   '; Parm:p0   ),  (Name:'AND'; Parm:pAbsX),
  (Name:'ROL'; Parm:pAbsX),  (Name:'RLA'; Parm:pAbsX),
 {40-4F}
  (Name:'RTI'; Parm:pImpl),  (Name:'EOR'; Parm:pIndX),
  (Name:'   '; Parm:p0   ),  (Name:'SRE'; Parm:pIndX),
  (Name:'   '; Parm:p0   ),  (Name:'EOR'; Parm:pZPge),
  (Name:'LSR'; Parm:pZPge),  (Name:'   '; Parm:p0   ),
  (Name:'PHA'; Parm:pImpl),  (Name:'EOR'; Parm:pImm ),
  (Name:'LSR'; Parm:pImpl),  (Name:'ASR'; Parm:pImm ),
  (Name:'JMP'; Parm:pAbso),  (Name:'EOR'; Parm:pAbso),
  (Name:'LSR'; Parm:pAbso),  (Name:'SRE'; Parm:pAbso),
 {50-5F}
  (Name:'BVC'; Parm:pRela),  (Name:'EOR'; Parm:pIndY),
  (Name:'   '; Parm:p0   ),  (Name:'SRE'; Parm:pIndY),
  (Name:'   '; Parm:p0   ),  (Name:'EOR'; Parm:pZPgX),
  (Name:'LSR'; Parm:pZPgX),  (Name:'SRE'; Parm:pZPgX),
  (Name:'CLI'; Parm:pImpl),  (Name:'EOR'; Parm:pAbsY),
  (Name:'   '; Parm:p0   ),  (Name:'SRE'; Parm:pAbsY),
  (Name:'   '; Parm:p0   ),  (Name:'EOR'; Parm:pAbsX),
  (Name:'LSR'; Parm:pAbsX),  (Name:'SRE'; Parm:pAbsX),
 {60-6F}
  (Name:'RTS'; Parm:pImpl),  (Name:'ADC'; Parm:pIndX),
  (Name:'   '; Parm:p0   ),  (Name:'RRA'; Parm:pIndX),
  (Name:'   '; Parm:p0   ),  (Name:'ADC'; Parm:pZPge),
  (Name:'ROR'; Parm:pZPge),  (Name:'RRA'; Parm:pZPge),
  (Name:'PLA'; Parm:pImpl),  (Name:'ADC'; Parm:pImm),
  (Name:'ROR'; Parm:pImpl),  (Name:'   '; Parm:p0   ),
  (Name:'JMP'; Parm:pInd ),  (Name:'ADC'; Parm:pAbso),
  (Name:'ROR'; Parm:pAbso),  (Name:'RRA'; Parm:pAbso),
 {70-7F}
  (Name:'BVS'; Parm:pRela),  (Name:'ADC'; Parm:pIndY),
  (Name:'   '; Parm:p0   ),  (Name:'RRA'; Parm:pIndY),
  (Name:'   '; Parm:p0   ),  (Name:'ADC'; Parm:pZPgX),
  (Name:'ROR'; Parm:pZPgX),  (Name:'RRA'; Parm:pZPgX),
  (Name:'SEI'; Parm:pImpl),  (Name:'ADC'; Parm:pAbsY),
  (Name:'   '; Parm:p0   ),  (Name:'RRA'; Parm:pAbsY),
  (Name:'   '; Parm:p0   ),  (Name:'ADC'; Parm:pAbsX),
  (Name:'ROR'; Parm:pAbsX),  (Name:'RRA'; Parm:pAbsX),
 {80-8F}
  (Name:'NOP'; Parm:pImm ),  (Name:'STA'; Parm:pIndX),
  (Name:'   '; Parm:p0   ),  (Name:'SAX'; Parm:pIndX),
  (Name:'STY'; Parm:pZPge),  (Name:'STA'; Parm:pZPge),
  (Name:'STX'; Parm:pZPge),  (Name:'SAX'; Parm:pZPge),
  (Name:'DEY'; Parm:pImpl),  (Name:'   '; Parm:p0   ),
  (Name:'TXA'; Parm:pImpl),  (Name:'ANE'; Parm:pImm ),
  (Name:'STY'; Parm:pAbso),  (Name:'STA'; Parm:pAbso),
  (Name:'STX'; Parm:pAbso),  (Name:'SAX'; Parm:pAbso),
 {90-9F}
  (Name:'BCC'; Parm:pRela),  (Name:'STA'; Parm:pIndY),
  (Name:'   '; Parm:p0   ),  (Name:'SHA'; Parm:pIndY),
  (Name:'STY'; Parm:pZPgX),  (Name:'STA'; Parm:pZPgX),
  (Name:'STX'; Parm:pZPgY),  (Name:'SAX'; Parm:pZpgX),
  (Name:'TYA'; Parm:pImpl),  (Name:'STA'; Parm:pAbsY),
  (Name:'TXS'; Parm:pImpl),  (Name:'SHS'; Parm:pAbsY),
  (Name:'SHY'; Parm:pAbsX),  (Name:'STA'; Parm:pAbsX),
  (Name:'SHX'; Parm:pAbsY),  (Name:'SHA'; Parm:pAbsY),
 {A0-AF}
  (Name:'LDY'; Parm:pImm),   (Name:'LDA'; Parm:pIndX),
  (Name:'LDX'; Parm:pImm),   (Name:'LAX'; Parm:pIndX),
  (Name:'LDY'; Parm:pZPge),  (Name:'LDA'; Parm:pZPge),
  (Name:'LDX'; Parm:pZPge),  (Name:'LAX'; Parm:pZPge),
  (Name:'TAY'; Parm:pImpl),  (Name:'LDA'; Parm:pImm),
  (Name:'TAX'; Parm:pImpl),  (Name:'LXA'; Parm:pImm ),
  (Name:'LDY'; Parm:pAbso),  (Name:'LDA'; Parm:pAbso),
  (Name:'LDX'; Parm:pAbso),  (Name:'LAX'; Parm:pAbso),
 {B0-BF}
  (Name:'BCS'; Parm:pRela),  (Name:'LDA'; Parm:pIndY),
  (Name:'   '; Parm:p0   ),  (Name:'LAX'; Parm:pIndY),
  (Name:'LDY'; Parm:pZPgX),  (Name:'LDA'; Parm:pZpgX),
  (Name:'LDX'; Parm:pZPgY),  (Name:'LAX'; Parm:pZpgY),
  (Name:'CLV'; Parm:pImpl),  (Name:'LDA'; Parm:pAbsY),
  (Name:'TSX'; Parm:pImpl),  (Name:'LAS'; Parm:pAbsY),
  (Name:'LDY'; Parm:pAbsX),  (Name:'LDA'; Parm:pAbsX),
  (Name:'LDX'; Parm:pAbsY),  (Name:'LAX'; Parm:pAbsY),
 {C0-CF}
  (Name:'CPY'; Parm:pImm ),  (Name:'CMP'; Parm:pIndX),
  (Name:'   '; Parm:p0   ),  (Name:'DCP'; Parm:pIndX),
  (Name:'CPY'; Parm:pZPge),  (Name:'CMP'; Parm:pZPge),
  (Name:'DEC'; Parm:pZPge),  (Name:'DCP'; Parm:pZPge),
  (Name:'INY'; Parm:pImpl),  (Name:'CMP'; Parm:pImm),
  (Name:'DEX'; Parm:pImpl),  (Name:'SBX'; Parm:pImm ),
  (Name:'CPY'; Parm:pAbso),  (Name:'CMP'; Parm:pAbso),
  (Name:'DEC'; Parm:pAbso),  (Name:'DCP'; Parm:pAbso),
 {D0-DF}
  (Name:'BNE'; Parm:pRela),  (Name:'CMP'; Parm:pIndY),
  (Name:'   '; Parm:p0   ),  (Name:'DCP'; Parm:pIndY),
  (Name:'   '; Parm:p0   ),  (Name:'   '; Parm:p0   ),
  (Name:'DEC'; Parm:pZPgX),  (Name:'DCP'; Parm:pZPgX),
  (Name:'CLD'; Parm:pImpl),  (Name:'CMP'; Parm:pAbsY),
  (Name:'   '; Parm:p0   ),  (Name:'DCP'; Parm:pAbsY),
  (Name:'   '; Parm:p0   ),  (Name:'CMP'; Parm:pAbsX),
  (Name:'DEC'; Parm:pAbsX),  (Name:'DCP'; Parm:pAbsX),
 {E0-EF}
  (Name:'CPX'; Parm:pImm ),  (Name:'SBC'; Parm:pIndX),
  (Name:'   '; Parm:p0   ),  (Name:'ISB'; Parm:pIndX),
  (Name:'CPX'; Parm:pZPge),  (Name:'SBC'; Parm:pZPge),
  (Name:'INC'; Parm:pZPge),  (Name:'ISB'; Parm:pZPge),
  (Name:'INX'; Parm:pImpl),  (Name:'SBC'; Parm:pImm),
  (Name:'NOP'; Parm:pImpl),  (Name:'   '; Parm:p0   ),
  (Name:'CPX'; Parm:pAbso),  (Name:'SBC'; Parm:pAbso),
  (Name:'INC'; Parm:pAbso),  (Name:'ISB'; Parm:pAbso),
 {F0-FF}
  (Name:'BEQ'; Parm:pRela),  (Name:'SBC'; Parm:pIndY),
  (Name:'D64'; Parm:pImm ),  (Name:'ISB'; Parm:pIndY),
  (Name:'   '; Parm:p0   ),  (Name:'SBC'; Parm:pZPgX),
  (Name:'INC'; Parm:pZPgX),  (Name:'ISB'; Parm:pZPgX),
  (Name:'SED'; Parm:pImpl),  (Name:'SBC'; Parm:pAbsY),
  (Name:'   '; Parm:p0   ),  (Name:'ISB'; Parm:pAbsY),
  (Name:'   '; Parm:p0   ),  (Name:'SBC'; Parm:pAbsX),
  (Name:'INC'; Parm:pAbsX),  (Name:'ISB'; Parm:pAbsX)
  );

Var
 c64file:string;

 handle:word;
 size  :word;
 RAM   :pointer;
 RAMSeg:word;

 loadat:word;
 endat :word;

 targets:array[0..MaxTarget-1] of word;
 targetcount:byte;
 t:integer;

 pc:word;
 ir:byte;
 pip2:word;
 pip1:byte absolute pip2;

 code:boolean;
 data:string;
 chars:string;

procedure AddTarget(ATarget:word);
 var
  t:integer;
 begin
  if (ATarget<loadat)or(ATarget>endat) then exit;
  for t:=1 to TargetCount-1 do if Targets[t]=ATarget then exit;
  if TargetCount=MaxTarget then begin
   writeln('Target overflow');
   halt;
  end;
  Targets[TargetCount]:=ATarget;
  inc(TargetCount);
{  writeln('; Target at ',HexaW(ATarget)); }
 end;

procedure ReadBasic;
 var
  index   :word;
  nextline:word;
  linenbr :word;
  i       :integer;
  c       :char;
  quote   :boolean;
  sys     :byte; { 0=not, 1=spaces, 2=reading }
  target  :word;
 begin
  writeln('.BASIC ; $0801');
  index:=0;

  Nextline:=MemW[RAMSeg:Index];
  inc(index,2);

  while (NextLine<>0) do begin

   LineNbr:=MemW[RAMSeg:Index];
   inc(index,2);

   write(linenbr,' ');

   quote:=false;
   sys:=0;
   target:=0;

   for i:=index to nextline-2-loadat do begin
    c:=chr(Mem[RAMSeg:i]);
    if c=#34 then quote:=not quote;
    if c=#0 then begin write('{#0}'); break; end else
    if quote then write(c) else
    if (c>#127)and(c<#204) then begin
     write(BasicTokens[c]);
     if c=#158{SYS} then sys:=1;
    end else begin
     case sys of
      1: if c in ['0'..'9'] then begin target:=10*target+ord(c)-ord('0'); sys:=2 end;
      2: if c in ['0'..'9'] then target:=10*target+ord(c)-ord('0') else sys:=0;
     end;
     write(c);
    end;
   end;
   if c=#0 then
    index:=i+1
   else begin
    index:=i+2{nextline-loadat};
    c:=chr(Mem[RAMSeg:Index-1]);
    if c<>#0 then write('{#',ord(c),'}');
   end;
   writeln;

   if Target>0 then AddTarget(Target);

   NextLine:=MemW[RAMSeg:Index];
   inc(index,2);
  end;

  writeln('; end of basic at $',HexaW(index+loadat));

  for t:=0 to TargetCount-1 do begin
   writeln(';BASIC call ASM at $',HexaW(Targets[t]));
  end;

  AddTarget(index+loadat);
  index:=Targets[TargetCount-1];
  if index<Targets[0] then begin
   Targets[TargetCount-1]:=Targets[0];
   Targets[0]:=index;
  end;
 end;

procedure pass1;
 begin
  repeat
   ir:=Mem[RAMSeg:pc];
   pip2:=MemW[RAMSeg:pc+1];
   case ir of
    $20: {JSR} AddTarget(pip2);
    $4C: {JMP} begin AddTarget(pip2); exit end;
    $40, {RTI}
    $60: {RTS} exit;
   end;
   if opCode[ir].Parm=pRela then AddTarget(pc+loadat+2+ShortInt(pip1));
   if opCode[ir].Name='   ' then exit;
   inc(pc,opSize[opCode[ir].Parm]);
  until (pc+loadat>endat);
 end;

procedure OutData;
 const
  remove:string=#7#8#9#10#13;
 var
  x:byte;
 begin
  if data='' then exit;
  while length(data)<3*16 do data:=data+'   ';
  for x:=1 to length(chars) do begin
   if pos(chars[x],remove)>0 then chars[x]:='.';
   if chars[x]<#32 then chars[x]:='.';
  end;
  writeln('.DATA ',data,' ''',chars);
  data:='';
  chars:='';
 end;

procedure pass2;
 begin
  for t:=0 to TargetCount-1 do
   if Targets[t]-loadat=pc then begin
    outdata;
    writeln('; Target found at ',HexaW(pc+loadat));
    code:=true;
    break;
   end;
  ir  :=Mem[RAMSeg:pc];
  if code then begin
   pip2:=MemW[RAMSeg:pc+1];
   with opCode[ir] do begin
    write(HexaW(pc+loadat),' ',HexaB(ir),' ');
    if name='   ' then begin
     write('      ???');
     code:=false;
    end else
    Case Parm of
     pImpl : Write('      ',Name);
     pAbso : Write(HexaB(pip1),' ',HexaB(hi(pip2)),' ',Name,' $'+HexaW(pip2));
     pZPge : Write(HexaB(pip1),'   ',' ',Name,' $'+HexaB(pip1));
     pImm  : Write(HexaB(pip1),'   ',' ',Name,' #$'+HexaB(pip1));
     pAbsX : Write(HexaB(pip1),' ',HexaB(hi(pip2)),' ',Name,' $'+HexaW(pip2)+'+X');
     pAbsY : Write(HexaB(pip1),' ',HexaB(hi(pip2)),' ',Name,' $'+HexaW(pip2)+'+Y');
     pIndX : Write(HexaB(pip1),'   ',' ',Name,' ($'+HexaB(pip1)+'+X)');
     pIndY : Write(HexaB(pip1),'   ',' ',Name,' ($'+HexaB(pip1)+')+Y');
     pZPgX : Write(HexaB(pip1),'   ',' ',Name,' $'+HexaB(pip1)+'+X');
     pZPgY : Write(HexaB(pip1),'   ',' ',Name,' $'+HexaB(pip1)+'+Y');
     pRela : Write(HexaB(pip1),'   ',' ',Name,' $'+HexaW(PC+loadat+2+ShortInt(pip1)));
     pInd  : Write(HexaB(pip1),' ',HexaB(hi(pip2)),' ',Name,' ($'+HexaW(pip2)+')');
    end;
    writeln;
    inc(pc,opSize[opCode[ir].Parm]);
   end;
   if ir in [$40,$4C,$60] then code:=false;
  end else begin
   if length(chars)=16 then outdata;
   data:=data+' '+HexaB(ir);
   chars:=chars+chr(ir);
   inc(pc);
  end;
 end;

Const
 Version='C=64 Disassembler v1.0, (c)1998 by Paul TOTH <tothpaul@multimania.com>';
var
 p:string;
 a:word;
 x:byte;
begin
 writeln(Version);

 c64file:=paramstr(1);

 if C64File='/?' then begin
  writeln('DC64 <FILE.P00|.PRG> [OUTPUTFILE] [/A 0000 [FFFF]]');
  writeln('DC64 IMPMIS.P00 IMPMIS.SRC /A C883 C983 CA83');
 end;

 handle:=openfile(c64file,fmRead);
 if handle=0 then exit;

 Size:=filesize(handle);

 if c64file[length(c64file)]='0' then begin { .P00 }
  SeekFile(Handle,$1A);
  Dec(Size,$1A);
 end;

 readfile(handle,loadat,2);
 dec(Size,2);

 getmem(ram,size); RAMSeg:=seg(ram^);
 readfile(handle,ram^,size);
 closefile(handle);

 endat:=loadat+Size-1;

 targetcount:=0;

 if paramcount>1 then begin
  t:=2;
  p:=paramstr(t);
  if p[1]<>'/' then begin
   assign(output,p);
   rewrite(output);
   writeln(';',version);
   if paramcount>2 then begin
    write(';');
    for t:=3 to paramcount do write(' ',paramstr(t));
    writeln;
   end;
   t:=3;
  end;
  if t<=paramcount then begin
   p:=paramstr(t);
   if (p<>'/a')and(p<>'/A') then begin
    writeln('Syntax error');
    exit;
   end;
   inc(t);
   while t<=paramcount do begin
    p:=paramstr(t);
    if length(p)>4 then
     writeln('Invalide adress ',p)
    else begin
     a:=0;
     for x:=1 to length(p) do begin
      a:=16*a+pos(upcase(p[x]),hexa)-1;
     end;
     addtarget(a);
    end;
    inc(t);
   end;
  end;
 end;

 writeln('; ',c64file,' load at $',HexaW(loadat),' - $',HexaW(endat));

 if loadat=$0801 then ReadBasic else AddTarget(loadat);

 if targetcount>0 then begin

  writeln('.CODE');

  t:=0;
  while t<TargetCount do begin
   pc:=Targets[t]-loadat;
   pass1;
   inc(t);
  end;

  pc   :=Targets[0]-loadat;
  Code :=True;
  Data :='';
  Chars:='';

  while pc<=endat-loadat do pass2;

 end;

 writeln('END');

end.